// cinetique fermentation du sucre en alcool

#include <gtk/gtk.h>
#include <string.h>
#include <math.h>
#include "genfen.h"
#include "../modevutil.h"

	// fonctions a renseigner obligatoirement
void inifen();
gboolean action(GtkWidget *widget,gpointer data);
void fraz(GtkWidget *widget,gpointer data);

	// autres fonctions
// initialisation du graphe (libelles)
void init_graph(FENGRA* pfg); 

//   struct de toutes les variables necessaires
typedef struct  {
gfloat horlog;
gfloat sucre0;
gfloat temp0;
gfloat vites;
gfloat varsucre;
gfloat sucre;
gfloat vartemp;
gfloat temp;
gfloat varalc;
gfloat alcool;
char etat[16];
} DATA_FERM;

	// declaration  et initialisation des donnees 
DATA_FERM ferm1 = {
0,	//gfloat horlog;
220,	//gfloat sucre0;
14,	//gfloat temp0;
1,	//gfloat vites;
0,	//gfloat varsucre;
220,	//gfloat sucre;
0,	//gfloat vartemp;
14,	//gfloat temp;
0,	//gfloat varalc;
0,	//gfloat alcool;
"attente",	//char etat[16];
//0,200,14,1,0,200,0,14,0,0,"inactif"
};
	// sauvegarde des donnees de l'iteration N-1
DATA_FERM svferm1;

//          donnees de la fenetre a afficher et/ou saisir avec libelles
// fen      1______________________________
	// macro deplacement dans la structure
#define DEPS(zz) (char*)&ferm1.zz-(char*)&ferm1.horlog
DEF_L_F2C ini_f1[] ={
{NULL,NULL,NULL,DEPS(sucre0),SAISNUM,10,NULL, "%0.2f","Sucre depart g/l"}, 
{NULL,NULL,NULL,DEPS(temp0),SAISNUM,10,NULL, "%0.2f","Temperature depart"}, 
{NULL,NULL,NULL,DEPS(vites),SAISNUM,10,NULL, "%0.2f","Vitesse"}, 
{NULL,NULL,NULL,-1,0,0,NULL,"",""},
{NULL,NULL,NULL,DEPS(varsucre),LIBNUM,20,NULL,"%0.2f", "Variation sucre"}, 
{NULL,NULL,NULL,DEPS(vartemp),LIBNUM,20,NULL,"%0.2f", "Variation temperature"}, 
{NULL,NULL,NULL,DEPS(varalc),LIBNUM,20,NULL,"%0.2f", "Variation alcool"}, 
{NULL,NULL,NULL,-1,0,0,NULL,"",""},
{NULL,NULL,NULL,0,LIBNUM,10,NULL,"%#0.2f", "Temps en h"}, 
{NULL,NULL,NULL,DEPS(sucre),LIBNUM,20,NULL,"%0.2f", "Sucre en cours"}, 
{NULL,NULL,NULL,DEPS(temp),LIBNUM,20,NULL,"%0.2f", "Temperature"}, 
{NULL,NULL,NULL,DEPS(alcool),LIBNUM,20,NULL,"%0.2f", "Alcool"}, 
{NULL,NULL,NULL,DEPS(etat),LIBCHAR,20,NULL,"%s", "Etat"}, 
{NULL,NULL,NULL,-1,-1,0,NULL,"",""},	// indispensable pour nb lignes
};
#undef DEPS


//          definition fenetres
F2C f1 = {	// fen 2 col libelle + donnee
NULL,
"Fermentation sucre",        // pointeur sur titre  fenetre 
280,	// largeur fenetre
0,	// hauteur  fenetre calculee
900,	// coin gauche x
150,	// coin gauche y
0,	// nb lignes calculee
&ini_f1[0]
};

//________fen graphique______________________
#define WIGR   840
#define HEIGR  480
FENGRA fg = {
NULL,
NULL,		//  drawing_area  
NULL,		  //  pixmap  
"graphe",        //  pointeur sur titre  fenetre  
WIGR+20,	// largeur fenetre 
HEIGR+50,	// hauteur  fenetre 
10,	//  coin gauche x 
10,	//  coin gauche y 
};

	// macro pour coordonnees graphe
#define MAXTEMPS	500
//#define COOX(zz) WIGR*zz/ferm1.dist2ville	// axe x distance
#define COOX(zz) WIGR*zz/MAXTEMPS	// 
#define COOYsuc(zz) HEIGR - HEIGR*zz/240	// 
#define COOYalc(zz) HEIGR - HEIGR*zz/16
#define COOYtemp(zz) HEIGR - HEIGR*zz/35

void init_graph( FENGRA* pfg)
{ 
gint y0,x0,z;//,y0,x1,y1;
char zn[40];
cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);
  cairo_set_source_rgb(cr, 1.0, 1.0, 1.0);	// blanc
  cairo_set_font_size(cr, 15.0);
z = MAXTEMPS / 2;
x0=COOX(z);
  sprintf(zn,"| %d h",z); 
  cairo_move_to(cr,x0, HEIGR+20);
  cairo_show_text(cr, zn);
z = WIGR - 80;
cairo_set_source_rgb(cr, 0, 1.0, 1.0);	// 
y0=COOYsuc(100);
  sprintf(zn,"-- %d g/l sucre",100); 
  cairo_move_to(cr,z, y0);
  cairo_show_text(cr, zn);
cairo_set_source_rgb(cr, 1.0, 0, 1.0);	// 
y0=COOYalc(10);
  sprintf(zn,"-- %d ° alcool",10); 
  cairo_move_to(cr,z, y0);
  cairo_show_text(cr, zn);
cairo_set_source_rgb(cr, 1.0, 0, 0);	// 
y0=COOYtemp(20);
  sprintf(zn,"-- %d ° C",20); 
  cairo_move_to(cr,z, y0);
  cairo_show_text(cr, zn);
cairo_destroy(cr);
}

void graph( FENGRA * pfg)
{
gint x0,y0,x1,y1;
cairo_t *cr;
cr = gdk_cairo_create(pfg->pixmap);

// coordonnee graph
x0=COOX(svferm1.horlog);
y0=COOYsuc(svferm1.sucre);
x1=COOX(ferm1.horlog);
y1=COOYsuc(ferm1.sucre);
  cairo_set_source_rgb(cr, 0, 1.0, 1.0);	// 
  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

y0=COOYalc(svferm1.alcool);
y1=COOYalc(ferm1.alcool);
  cairo_set_source_rgb(cr, 1.0, 0, 1.0);	// 
  cairo_move_to(cr, x0,y0);
//printf("graph 2\n");
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

y0=COOYtemp(svferm1.temp);
y1=COOYtemp(ferm1.temp);
  cairo_set_source_rgb(cr, 1.0, 0, 0);	// 
  cairo_move_to(cr, x0,y0);
  cairo_line_to(cr, x1, y1);
  cairo_stroke(cr);

  gtk_widget_queue_draw (pfg->da);  
//  gtk_widget_queue_draw_area (pfg->da, x0,y0, x1,y1);  
cairo_destroy(cr);

}

static gboolean calcul(DATA_FERM* pd)
{
DATA_FERM* psv = &svferm1;
	// sauve valeur iter -1
memcpy((char*)&svferm1,(char*)&ferm1, sizeof(DATA_FERM));
	// varsucre proportionnel quant sucre et vitesse / 100
pd->varsucre=pd->vites*pd->sucre/100;
pd->sucre=psv->sucre-pd->varsucre;
// temperature augmente 1/10 varsucre diminue 2/100 ecart avec temp0
pd->vartemp=pd->varsucre*0.1 - (pd->temp - pd->temp0) * 0.02;
pd->temp=psv->temp + pd->vartemp;
pd->varalc=pd->varsucre/17;
pd->alcool=psv->alcool+pd->varalc;
	// vitesse double quand temperature + 10
	// vitesse = 1 a temperature = 16
pd->vites = 1 + (pd->temp - 16) / 16;
//pd->vites = pd->temp/psv->temp*psv->vites;
  pd->horlog=pd->horlog+1;
  strcpy((char*)pd->etat,"en action");
  graph((FENGRA *) &fg);
	// on veut un stop a horlog = 120
if ( pd->horlog == 120)	{
 fstop(NULL,NULL);
 strcpy((char*)pd->etat,"stop programme");
			}
if (pd->sucre > 2 ) return TRUE;
else {
  strcpy((char*)pd->etat,"arret");
  return FALSE;
    }
}

// initialisation_
int main(int argc, char** argv)
{
  gtk_init(&argc, &argv);
  modevmenu();
  inifen();
  gtk_main();
  return 0;
}

//________creation fenetres
void inifen()
{
cre_fen2c_sais( (F2C *) &f1,(DATA_FERM*) &ferm1);
aff_fen2c_sais((F2C *) &f1,(DATA_FERM*) &ferm1);
gtk_widget_show_all(f1.win);
//________fen graphique______________________
crefengra ( (FENGRA *) &fg.wingrap);
gtk_widget_show_all (fg.wingrap);
	// iteration declanchee tous les xx en 1/1000 de seconde
tousles = 10;	// definie dans modevutil.c
	//init graph
init_graph( (FENGRA *) &fg.wingrap); 
}

//  fonctions generiques modev__________________________

//  fonction action _________________________________________
static gboolean ret1 = TRUE;

gboolean action(GtkWidget *widget,gpointer data)	// execution d'une phase
{
if ( ret1) {
	if ( calcul( (DATA_FERM*) &ferm1) == FALSE)
	ret1 = FALSE;
	aff_fen2c_sais((F2C *) &f1,(DATA_FERM*) &ferm1);
	}
if ( !ret1 )	{
	fstop(NULL,NULL);
	return FALSE;
			}
return TRUE;
}

	// on reinitialise (apres saisie)
void fraz(GtkWidget *widget,gpointer data)
{
DATA_FERM* pd = &ferm1;
pd->horlog=0;
pd->sucre = pd->sucre0;
pd->temp = pd->temp0;
pd->alcool = 0;
//strcpy((char*)pd->etat,"en action");
ret1 = TRUE;
aff_fen2c_sais((F2C *) &f1,(DATA_FERM*) &ferm1);
	// efface graphe
if ( question(2) == 0)	{
cairo_t *cr;
//cr = gdk_cairo_create(pfg->da->window);
cr = gdk_cairo_create(fg.pixmap);
cairo_set_source_rgb(cr, 0, 0, 0);	
cairo_paint (cr);
gtk_widget_queue_draw (fg.da);  
init_graph( (FENGRA *) &fg.wingrap); 
			}
}

