// 	Auteur	Michel Delorme	Logiciel Libre	Free software
//  Routines de creation de fenetre et tableaux

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <string.h>
#include "genfen.h"

gboolean maj_f2c ();	//  controle, maj
gboolean focout_f2c (GtkWidget *widget, GdkEventKey *event, DEF_L_F2C *pl);
void chang_f2c (GtkEntry *widls, DEF_L_F2C *pl);
void activ_f2c (GtkWidget *widls, DEF_L_F2C *pl);
void act_l_f2c (DEF_L_F2C *pl);

extern S_DAT da;

char buf[80];
DEF_L_F2C *svpl;
int bloqchf2c=0; // inhibe signal change si affichage


gboolean maj_f2c ()	//  controle, maj
{
int lt,ret=0;
DEF_L_F2C *pl = svpl;	// widget actif dans change
GtkEditable *editable;
gchar *text;
char *pa;
float* paf;
int* pai; 
if ( svpl == NULL)	{
	printf("maj_f2c svpl=NULL ?\n");
	return TRUE;
			}
 editable = GTK_EDITABLE (pl->winit);
 text = gtk_editable_get_chars (editable, 0, -1);
 lt = strlen(text);
 pa = pl->memcell;
if (pl->typ == SAISNUM || pl->typ == SAISMON)   {
  paf = (float*) pa;
  *(paf) = g_strtod(text,NULL);
			}
else if (pl->typ == SAISINT)   {
  pai = (int*) pa;
  *(pai) = atoi(text);
			}
else if (pl->typ == SAISDAT)   {
  if ( (ret = contdate((char*)text)) >= 0)
   strncpy((char*)pa,da.sdat,pl->laf); 
  else message(13);
			}
else {  //typ=char,SSPEC
 if ( lt > pl->laf)  message(1); //lt=pl->laf;
 strncpy((char*)pa,text,pl->laf); // efface fin de saisie precedente
	}
 if (pl->fonc && ret >= 0)  {		// ret =date vide ou ok
	ret = (*(pl->fonc)) (pl,0) ;  
		 }
svpl = NULL;	// tout le traitement apres saisie a du etre fait
//printf("maj_fenq-2 pl=%p ret=%d\n",pl,ret);
if (ret == -1) {
 if (pl->laf == 1)  gtk_editable_delete_text((GtkEditable*) editable,0,-1);
   gtk_editable_set_position((GtkEditable*) editable,0);
   g_free(text);	
   gtk_widget_grab_focus (pl->winit); 
   return TRUE;
		}
g_free(text);		
return FALSE;
}



gboolean focout_f2c (GtkWidget *widget, GdkEventKey *event, DEF_L_F2C *pl)
{
//pw fait ref au widget suivant
//printf("focus-out  pl=%p svpl=%p\n",pl,svpl);
if (svpl != NULL) maj_f2c();
  return FALSE;
}


void chang_f2c (GtkEntry *widls, DEF_L_F2C *pl)	// CHANGE
{		// attention active par affichage sans saisie
int lt;
GtkEditable *editable;
gchar *text;
if (bloqchf2c == 1) return;
svpl = pl;	//sauvegarde du widget saisie  a traiter
//printf("chang_fenq pl=%p \n",pl);
if (pl->typ == SSPEC) { // traitement specifique
 if (pl->fonc)  {
  (*(pl->fonc)) (pl,1) ;  
		 }
  return;
 			}
else if (pl->typ > 19 )     { //&& lt > 0)   {  
    lt=chang_ctrl(widls,pl->typ);
			}
else 	{
    editable = GTK_EDITABLE (widls);
    text = gtk_editable_get_chars (editable, 0, -1);
    lt = strlen(text);
    g_free(text);
	}
if ( lt == pl->laf )
 g_signal_emit_by_name(widls,"move-focus",GTK_DIR_TAB_FORWARD,pl);
}



void activ_f2c (GtkWidget *widls, DEF_L_F2C *pl)
{
g_signal_emit_by_name(widls,"move-focus",GTK_DIR_TAB_FORWARD,pl);
}

void act_l_f2c (DEF_L_F2C *pl)
{
//void *px = pl;
if ( pl->deps == -1) return;
if ( pl->typ < 10)
 pl->winit =  gtk_label_new((char *) "");
else {
 pl->winit =  gtk_entry_new_with_max_length(pl->laf);
// gtk_widget_set_size_request(pl->winit, pl->laf * 4, 20);
 gtk_widget_set_size_request(pl->winit, pl->laf * DIMC, 20);
//printf("laf= %d\n",pl->laf);
g_signal_connect(G_OBJECT(pl->winit), "activate", G_CALLBACK (activ_f2c),(void*) pl);
g_signal_connect((GtkEntry*) pl->winit, "changed", G_CALLBACK (chang_f2c),(void*) pl);
g_signal_connect_after((GtkEntry*) pl->winit, "focus-out-event", G_CALLBACK (focout_f2c),(void*) pl);
	}
}

#define HLIG 16
void cre_fen2c_sais (F2C* pf,void* pd)	// creation fenetre 2col libel+val
{
int  j;
char *pa;
DEF_L_F2C *pti = pf->ptabini;
GtkWidget* fixg;  //pf->vboxwin
GtkWidget* tabwin;  
	// calcul nb lignes
j = 0;
while ( (pti+j)->typ != -1) ++j;
pf->tli = ++j;
pf->fenhaut = pf->tli * HLIG;

 pf->win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
 gtk_window_move(GTK_WINDOW(pf->win), pf->posx, pf->posy);
 gtk_window_set_default_size(GTK_WINDOW(pf->win), pf->fenlarg, pf->fenhaut);
 gtk_window_set_title(GTK_WINDOW(pf->win), pf->fentit);
 gtk_container_set_border_width(GTK_CONTAINER(pf->win), 0);
//
 fixg = gtk_vbox_new(FALSE, 1);
 gtk_container_add(GTK_CONTAINER(pf->win), fixg);

 tabwin = gtk_table_new(pf->tli, 2, FALSE);	//2 col
 gtk_table_set_row_spacings(GTK_TABLE(tabwin), 0);
 gtk_table_set_col_spacings(GTK_TABLE(tabwin), 0);
 gtk_box_pack_start(GTK_BOX(fixg), tabwin, TRUE, TRUE, 1);
// gtk_box_pack_start(GTK_BOX(fixg), tabwin, FALSE, TRUE, 0);
 for( j=0; j < pf->tli; j++) {
   (pti+j)->wlibel =  gtk_label_new((char *) (pti+j)->libel);
//gtk_label_set_justify (GTK_LABEL(tablib[j][1]), GTK_JUSTIFY_LEFT);
   gtk_table_attach_defaults(GTK_TABLE(tabwin), (pti+j)->wlibel, 0, 1, j, j+1 );
	}
 for( j=0; j < pf->tli; j++) 	{
   if ( (pti+j)->deps != -1) 	{
    pa = (char*)pd +(int)(pti+j)->deps;
    (pti+j)->memcell = pa;
    act_l_f2c( pti+j);
//printf("cre pl(pti+j)= %0x memcell= %0x lib= %s\n",(pti+j),(pti+j)->memcell,(pti+j)->libel);
    gtk_table_attach_defaults(GTK_TABLE(tabwin), (pti+j)->winit, 1, 2, j, j+1 );
				}
				}
}

// affich fenetre 2 colonnes libelle + valeur
//  void* pd doit pointer sur une struct de variables calculees en correspondance avec DEF_L_F2C
void aff_fen2c_sais(F2C* pf,void* pd)
{	// buf doit etre declare en global ?
int j;
DEF_L_F2C *pti = pf->ptabini;
char *pa;
int* pai; 
float* paf;
bloqchf2c=1;
for( j=0; j < pf->tli; j++) {
  if ( (pti+j)->deps == -1) continue;
  pa = (char*)pd +(int)(pti+j)->deps;
  if ( (pti+j)->typ == SAISNUM || (pti+j)->typ == LIBNUM
	 || (pti+j)->typ == SAISMON)   {
   paf = (float*) pa;
   sprintf(buf, (pti+j)->forma,  *paf);
				}
  else if ( (pti+j)->typ == SAISINT || (pti+j)->typ == LIBINT)   {
   pai = (int*) pa;
   sprintf(buf, (pti+j)->forma,  *pai);
				}
  else 	{
	sprintf(buf, (pti+j)->forma,  pa);
	}

/*  if ( *((pti+j)->forma + 1) == 's')
	sprintf(buf, (pti+j)->forma,  pa);
  else {
	paf = (float*) pa;
	sprintf(buf, (pti+j)->forma,  *paf);
	}*/
  if ( (pti+j)->typ < 10)
   gtk_label_set_text(GTK_LABEL((pti+j)->winit), buf);
  else 
   gtk_entry_set_text(GTK_ENTRY((pti+j)->winit), buf);
	}
bloqchf2c=0;
}


